svn commit: r285880 - user/pho/stress2/misc

Peter Holm pho at FreeBSD.org
Sat Jul 25 19:30:28 UTC 2015


Author: pho
Date: Sat Jul 25 19:30:26 2015
New Revision: 285880
URL: https://svnweb.freebsd.org/changeset/base/285880

Log:
  Added regression tests for r285878.
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/mmap23.sh   (contents, props changed)
  user/pho/stress2/misc/mmap24.sh   (contents, props changed)
  user/pho/stress2/misc/mmap25.sh   (contents, props changed)
  user/pho/stress2/misc/mmap26.sh   (contents, props changed)

Added: user/pho/stress2/misc/mmap23.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap23.sh	Sat Jul 25 19:30:26 2015	(r285880)
@@ -0,0 +1,111 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2015 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# "panic: vm_object_unwire: missing page" seen.
+# https://people.freebsd.org/~pho/stress/log/mmap23.txt
+# Test scenario by kib at .
+# Fixed by r285878.
+
+. ../default.cfg 
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/mmap23.c
+mycc -o mmap23 -Wall -Wextra mmap23.c || exit 1
+rm -f mmap23.c
+cd $odir
+
+cp /tmp/mmap23 /tmp/mmap23.inputfile
+daemon sh -c '(cd ../testcases/swap; ./swap -t 1m -i 2)' > \
+    /dev/null 2>&1
+
+/tmp/mmap23 /tmp/mmap23.inputfile &
+sleep .2
+dd if=/dev/zero of=/tmp/mmap23.inputfile bs=1k count=1 2>&1 | \
+    egrep -v "records|transferred"
+
+while ps auxww | grep -v grep | grep -qw swap; do
+	killall -9 swap 2>/dev/null
+done
+
+rm -f /tmp/mmap23 /tmp/mmap23.inputfile
+exit
+
+EOF
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+const char *file;
+
+void
+test(void)
+{
+	struct stat st;
+	char *p;
+	size_t len;
+	int error, fd;
+
+	if ((fd = open(file, O_RDWR)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	if ((p = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) == MAP_FAILED)
+		err(1, "mmap");
+	p[arc4random() % len] = 1;
+	if ((error = mlock(p, len)) == -1)
+		err(1, "mlock");
+	sleep(2);
+	if (munmap(p, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+}
+
+int
+main(int argc, char *argv[])
+{
+	if (argc != 2)
+		errx(1, "Usage: %s <file>", argv[0]);
+	file = argv[1];
+
+	test();
+
+	return (0);
+}

Added: user/pho/stress2/misc/mmap24.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap24.sh	Sat Jul 25 19:30:26 2015	(r285880)
@@ -0,0 +1,100 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2015 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# "panic: vm_page_unwire: page 0xc36cafbc's wire count is zero" seen.
+# https://people.freebsd.org/~pho/stress/log/mmap24.txt
+# Test scenario by trasz at .
+# Fixed by r285878.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/mmap24.c
+mycc -o mmap24 -Wall -Wextra mmap24.c || exit 1
+rm -f mmap24.c
+cd $odir
+
+[ -c /dev/md$mdstart ] && mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 1g -u $mdstart || exit 1
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+chmod 777 $mntpoint
+
+cp /tmp/mmap24 $mntpoint
+(cd $mntpoint; ./mmap24) &
+sleep .2
+umount -f $mntpoint
+
+kill $!
+wait
+
+while mount | grep "on $mntpoint " | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+
+rm -f /tmp/mmap24
+exit
+
+EOF
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+#include <sys/mman.h>
+#include <err.h>
+#include <stdio.h>
+#include <unistd.h>
+
+int
+main(void)
+{
+        int error;
+
+        error = mlockall(MCL_CURRENT | MCL_FUTURE);
+        if (error != 0)
+                err(1, "mlockall");
+
+        for (;;) {
+                sleep(1);
+        }
+}

Added: user/pho/stress2/misc/mmap25.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap25.sh	Sat Jul 25 19:30:26 2015	(r285880)
@@ -0,0 +1,122 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2015 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# "panic: vm_page_unwire: page 0xc36cce48's wire count is zero" seen.
+# Fixed by r285878.
+
+# Test scenario by kib@:
+# 1. We mapped and mlocked the file.
+# 2. The file is truncated
+# 3. The file is extended again to cover the whole mapped area.
+# 4. The program accesses the mapping past the point of truncation.
+
+. ../default.cfg 
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/mmap25.c
+mycc -o mmap25 -Wall -Wextra mmap25.c || exit 1
+rm -f mmap25.c
+cd $odir
+
+cp /tmp/mmap25 /tmp/mmap25.inputfile
+daemon sh -c '(cd ../testcases/swap; ./swap -t 1m -i 2)' > \
+    /dev/null 2>&1
+sleep 1
+
+/tmp/mmap25 /tmp/mmap25.inputfile
+
+while ps auxww | grep -v grep | grep -qw swap; do
+	killall -9 swap 2>/dev/null
+done
+rm -f /tmp/mmap25 /tmp/mmap25.inputfile mmap25.core
+exit
+
+EOF
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+const char *file;
+volatile char c;
+
+void
+test(void)
+{
+	struct stat st;
+	char *p;
+	size_t len;
+	off_t pos;
+	int error, fd;
+
+	if ((fd = open(file, O_RDWR)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	pos = len - getpagesize();
+	if ((p = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0))
+	    == MAP_FAILED)
+		err(1, "mmap");
+	if ((error = mlock(p, len)) == -1)
+		err(1, "mlock");
+
+	if (ftruncate(fd, pos) == -1)
+		err(1, "ftruncate 1");
+	if (ftruncate(fd, len) == -1)
+		err(1, "ftruncate 2");
+
+	c = p[pos];	/* Program received signal SIGSEGV, Segmentation fault. */
+
+	if (munmap(p, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+}
+
+int
+main(int argc, char *argv[])
+{
+	if (argc != 2)
+		errx(1, "Usage: %s <file>", argv[0]);
+	file = argv[1];
+
+	test();
+
+	return (0);
+}

Added: user/pho/stress2/misc/mmap26.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/mmap26.sh	Sat Jul 25 19:30:26 2015	(r285880)
@@ -0,0 +1,126 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2015 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# "panic: vm_page_unwire: page 0xc36cce48's wire count is zero" seen.
+# https://people.freebsd.org/~pho/stress/log/kostik820.txt
+# Fixed by r285878.
+
+# Variation of mmap25.sh:
+# Access one byte past the end of the file, which is not wrong, but
+# out of specified behaviour.
+
+. ../default.cfg
+
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/$0 > $dir/mmap26.c
+mycc -o mmap26 -Wall -Wextra mmap26.c || exit 1
+rm -f mmap26.c
+cd $odir
+
+cp /tmp/mmap26 /tmp/mmap26.inputfile
+daemon sh -c '(cd ../testcases/swap; ./swap -t 1m -i 2)' > \
+    /dev/null 2>&1
+sleep 1
+
+(cd /tmp; /tmp/mmap26 /tmp/mmap26.inputfile)
+
+while ps auxww | grep -v grep | grep -qw swap; do
+	killall -9 swap 2>/dev/null
+done
+rm -f /tmp/mmap26 /tmp/mmap26.inputfile /tmp/mmap26.core
+exit
+
+EOF
+#include <sys/fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+const char *file;
+volatile char c;
+
+void
+test(void)
+{
+	struct stat st;
+	char *p;
+	size_t len;
+	int error, fd;
+
+	if ((fd = open(file, O_RDWR)) == -1)
+		err(1, "open %s", file);
+	if ((error = fstat(fd, &st)) == -1)
+		err(1, "stat(%s)", file);
+	len = round_page(st.st_size);
+	if ((p = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0))
+	    == MAP_FAILED)
+		err(1, "mmap");
+	if ((error = mlock(p, len)) == -1)
+		err(1, "mlock");
+
+	if (ftruncate(fd, (off_t)0) == -1)
+		err(1, "ftruncate 1");
+	if (ftruncate(fd, len) == -1)
+		err(1, "ftruncate 2");
+
+	p[len - 1] = 1;
+
+	/* one byte past EOF */
+	if (round_page(p + len) == round_page(p + len - 1)) {
+		fprintf(stderr, "Expect: Segmentation fault (core dumped)\n");
+		c = p[len];
+	}
+
+	if (munmap(p, len) == -1)
+		err(1, "unmap()");
+	close(fd);
+}
+
+int
+main(int argc, char *argv[])
+{
+	if (argc != 2)
+		errx(1, "Usage: %s <file>", argv[0]);
+	file = argv[1];
+
+	test();
+
+	return (0);
+}


More information about the svn-src-user mailing list